/*
 * ClickToAddress for Woocommerce by Crafty Clicks
 *
 * @author		Crafty Clicks Limited
 * @link		https://craftyclicks.co.uk
 * @copyright	Copyright (c) 2016, Crafty Clicks Limited
 * @license		Licensed under the terms of the MIT license.
 * @version		1.0.8
 */

function c2a_autocomplete_add_lookup(wooCfg){
	if (!jQuery('#'+wooCfg.prefix+'_cc_c2a_search_input').length) {
		var tmp_html = '<p class="form-row form-row form-row-wide address-field">'+
		'<label id="crafty_find_label_'+wooCfg.prefix+'">Find Address</label>'+
		'<input id="'+wooCfg.prefix+'_cc_c2a_search_input" class="input-text cc_c2a_search_input" type="text"></input>'+
		'</p>';
		jQuery(tmp_html).insertBefore(jQuery(wooCfg.fields.country_obj).parents('p'));
		var dom = {
			line_1:		wooCfg.fields.street1_obj[0],
			line_2:		wooCfg.fields.street2_obj[0],
			town:		wooCfg.fields.town_obj[0],
			postcode:	wooCfg.fields.postcode_obj[0],
			county:		wooCfg.fields.county_obj,
			country:	wooCfg.fields.country_obj[0]
		};
		if(cc_c2a_config.hide_fields && wooCfg.fields.town_obj.val() === ''){
			var tmp_html = '<p style="float:right;cursor: pointer;margin-bottom:0;font-size:0.8125em" class="cc_c2a_manual" id="cc_c2a_manual_'+wooCfg.prefix+'">Enter address manually</p>'
			jQuery(tmp_html).insertBefore(jQuery('#crafty_find_label_'+wooCfg.prefix));
			// grab all dom elements to be hidden, and mark them with an attribute
			var domKeys = Object.keys(dom);
			for(var iDom=0; iDom < domKeys.length; iDom++){
				jQuery(dom[domKeys[iDom]]).closest('.form-row').attr('cc-c2a-hide', 1);
			}
			jQuery(wooCfg.fields.county_obj.selector).closest('.form-row').attr('cc-c2a-hide', 1);
			setTimeout(function(){
				jQuery('[cc-c2a-hide="1"]').hide();
			}, 250);
			jQuery('#cc_c2a_manual_'+wooCfg.prefix).click(function(){
				jQuery('.woocommerce-'+wooCfg.prefix+'-fields').find('[cc-c2a-hide=1]').show();
				jQuery('#cc_c2a_manual_'+wooCfg.prefix).hide();
			});
		}
		dom.company = wooCfg.fields.company_obj[0];
		dom.search = jQuery('#'+wooCfg.prefix+'_cc_c2a_search_input')[0];
		c2a_autocomplete_search.attach(dom);
	}
}

jQuery(document).ready(function(){
	var c2a_autocomplete_config = {
		tag: 			'woocommerce',
		accessToken: 	cc_c2a_config.access_token,
		domMode:		'object',
		gfxMode:		cc_c2a_config.layout,
		style:{
			ambient:	'light',
			accent:		'default'
		},
		showLogo:		true,
		onSetCounty: function(c2a, elements, address){
			return;
		},
		onResultSelected: function(c2a, elements, address){
			jQuery(elements.country).val(address.country.iso_3166_1_alpha_2).trigger('change');
			c2a.setCounty(jQuery(elements.county.selector)[0], {
				'code': address.province_code,
				'name': address.province_name,
				'preferred': address.province
			});
			jQuery(elements.county.selector).trigger('change');
			var form = jQuery(elements.country).closest('div');
			form.find('[cc-c2a-hide="1"]').show();
			form.find('.cc_c2a_manual').hide();
			form.find('.cc_c2a_search_input').val('');
		},
		onError: function(){
			jQuery('[cc-c2a-hide="1"]').show();
		}
	};
	c2a_autocomplete_search = new clickToAddress(c2a_autocomplete_config);
	if (jQuery('#billing_postcode').length) {
		c2a_autocomplete_add_lookup({
			prefix:				'billing',
			fields:{
				postcode_obj:	jQuery('#billing_postcode'),
				company_obj:	jQuery('#billing_company'),
				street1_obj:	jQuery('#billing_address_1'),
				street2_obj:	jQuery('#billing_address_2'),
				town_obj:		jQuery('#billing_city'),
				county_obj:		{
					selector: '#billing_state'
				},
				country_obj:	jQuery('#billing_country')
			}
		});
	}
	if (jQuery('#shipping_postcode').length) {
		c2a_autocomplete_add_lookup({
			prefix:				'shipping',
			fields:{
				postcode_obj:	jQuery('#shipping_postcode'),
				company_obj:	jQuery('#shipping_company'),
				street1_obj:	jQuery('#shipping_address_1'),
				street2_obj:	jQuery('#shipping_address_2'),
				town_obj:		jQuery('#shipping_city'),
				county_obj:		{
					selector: '#shipping_state'
				},
				country_obj:	jQuery('#shipping_country')
			}
		});
	}
});
